<?php
require('geoip.class.php');

GeoIP::SetDBFileName('geolitecity.bin');

function test($ip, $expectedCC, $expectedRC, $expectedCity, $expectedLat, $expectedLng)
{
	$data = GeoIP::LookupIP($ip);
	echo $ip;
	echo ': ' . $data['cc'] . ', ' . $data['region'] . ', ' . $data['city'] . ' (' . $data['lat'] . ',' . $data['lng'] . ')';

	$error = '';
	if ($data['cc'] != $expectedCC)
		$error .= ' <span style="color: red;">[ERROR: expected cc=' . $expectedCC . ']</span>';
	if ($data['region'] != $expectedRC)
		$error .= ' <span style="color: red;">[ERROR: expected region=' . $expectedRC . ']</span>';
	if ($data['city'] != $expectedCity)
		$error .= ' <span style="color: red;">[ERROR: expected city=' . $expectedCity . ']</span>';
	if ($data['lat'] . '' != $expectedLat)
		$error .= ' <span style="color: red;">[ERROR: expected lat=' . $expectedLat . ']</span>';
	if ($data['lng'] . '' != $expectedLng)
		$error .= ' <span style="color: red;">[ERROR: expected lng=' . $expectedLng . ']</span>';

	if ($error)
		echo $error;
	else
		echo ' <span style="color: green;">[OK]</span>';
	echo "\n";
}

echo '<pre>';

$t0 = microtime(true);

test('1.1.1.1', 'AU', '', '', -27, 133);
test('133.234.67.87', 'JP', '', '', 36, 138);
test('80.12.34.56', 'FR', '', '', 46, 2);
test('97.231.45.67', 'US', '', '', 38, -97);
test('98.231.45.67', 'US', 'Florida', 'Jacksonville', 30.3447, -81.7354);
test('99.231.45.67', 'CA', 'Ontario', 'Toronto', 43.6667, -79.4167);
test('120.231.45.67', 'CN', 'Beijing', 'Beijing', 39.9289, 116.3883);
test('145.231.45.67', 'FR', '', '', 46, 2);
test('187.231.45.67', 'MX', '', '', 23, -102);
test('32.231.45.67', 'US', 'New Jersey', 'Middletown', 40.3965, -74.1075);
test('2a01:4f8:121:5161::2', 'DE', '', '', 51, 9);
test('2001:4860:b007::68', 'US', '', '', 38, -97);

echo 'Time: ' . round((microtime(true) - $t0) * 1000, 2) . " ms\n";

?>
